// For general information on the Pynini grammar compilation library, see
// pynini.opengrm.org.

#include <fst/script/fst-class.h>
#include <fst/script/script-impl.h>
#include "mergescript.h"

namespace fst {
namespace script {

bool MergeSymbols(MutableFstClass *fst1, MutableFstClass *fst2,
                  MergeSymbolsType mst) {
  if (!ArcTypesMatch(*fst1, *fst2, "MergeSymbols")) return false;
  MergeSymbolsInnerArgs iargs(fst1, fst2, mst);
  MergeSymbolsArgs args(iargs);
  Apply<Operation<MergeSymbolsArgs>>("MergeSymbols", fst1->ArcType(), &args);
  return args.retval;
}

REGISTER_FST_OPERATION(MergeSymbols, StdArc, MergeSymbolsArgs);
REGISTER_FST_OPERATION(MergeSymbols, LogArc, MergeSymbolsArgs);
REGISTER_FST_OPERATION(MergeSymbols, Log64Arc, MergeSymbolsArgs);

}  // namespace script
}  // namespace fst

